
//================================================================
#ifndef _LEVEL_H_
#define _LEVEL_H_
//================================================================
//hlavickovy subor pre prcu s celm okolnm svetom, niepriatelske
//lietadla, budovy, objekty


//defines
#define Max_MesserSchmitt 5
#define Max_Volkers       5
#define Max_Bombarders    3
#define Max_Structures    500
#define Max_Trucks        50 

//----------------------------------------------------------------
// Name: LEVEL class
// Desc: praca s okolnym svetom
//----------------------------------------------------------------
class LEVEL
{
private:

	
public:

	//---OBJEKTY---

	//vseobecne
	void AddCountryBasic();
	void AddDesertBasic();

	//Messerschmitt
	MESSERSCHMITT MesserSchmitt[Max_MesserSchmitt];
	void AddMesserSchmitt(int Index,int Life,int Mode,VECTOR3D Pos,VECTOR3D Rot, float OnTime);
	void AddMesserSchmittQuick(int Index,int Life,int Mode,VECTOR3D Pos,VECTOR3D Rot);

	//Volker
	VOLKER Volker[Max_Volkers];
	void AddVolker(int Index,int Life,VECTOR3D Pos,VECTOR3D Rot, float OnTime);
	void AddVolkerQuick(int Index,int Life,VECTOR3D Pos,VECTOR3D Rot);
	
	//Bombarders
	BOMBARDER Bombarder[Max_Bombarders];
	void AddBombarder(int Index,int Life,int Mode,VECTOR3D Target,VECTOR3D Pos, VECTOR3D Rot, float OnTime);

	//Structures
	STRUCTURE Structure[Max_Structures];
	void AddStructure(int Index,int ModelIndex, int Mode, VECTOR3D Pos, VECTOR3D Rot);
	void DestroyStructure(int Index);

	//trucks
	TRUCK Truck[Max_Trucks];
	void AddTruck(int Index,int Mode,VECTOR3D Pos,VECTOR3D Rot);

	//cas
	float StageTime;  //cas odpocitavania
	float MaxTime;    //cas za ktoru sa musi prejst misia

	float TimeBuffer1; //zasobnik casu 
	float TimeBuffer2; //zasobnik casu 
	float TimeBuffer3; //zasobnik casu 
	float TimeBuffer4; //zasobnik casu 
	float TimeBuffer5; //zasobnik casu 

	//---KRAJINA---
	OCTREE Krajina;
	
	//---OBECNE----
	void Initialize();
	void Refresh();
	void Destroy();
	void StopAllSounds();

	//----LEVELS---
	int LevelIndex; //aky level nasteduje
	
	void ProccesLevel();  //pridavanie objektov
	void DestroyLevel();
	
	//----General Start Level---
	void StartGame(int Level);


};


//================================================================
#endif //_LEVEL_H_


